services:
  broker:
    container_name: paperless-broker
    image: docker.io/library/redis:8
    restart: unless-stopped
    volumes:
      - /home/ccalifice/docker-data/paperless/redisdata:/data

  db:
    image: docker.io/library/postgres:18
    restart: unless-stopped
    volumes:
      - /home/ccalifice/docker-data/paperless/pgdata:/var/lib/postgresql
    environment:
      POSTGRES_DB: paperless
      POSTGRES_USER: paperless
      POSTGRES_PASSWORD: paperless
    container_name: paperless-db

  webserver:
    image: ghcr.io/paperless-ngx/paperless-ngx:latest
    container_name: paperless-ngx
    restart: unless-stopped
    depends_on:
      - db
      - broker
      - gotenberg
      - tika
    ports:
      - "8000:8000"
    volumes:
      - /home/ccalifice/docker-data/paperless/data:/usr/src/paperless/data
      - /home/ccalifice/docker-data/paperless/media:/usr/src/paperless/media
      - /home/ccalifice/docker-data/paperless/export:/usr/src/paperless/export
      - /home/ccalifice/docker-data/paperless/consume:/usr/src/paperless/consume
    env_file: .docker-compose.env
    environment:
      PAPERLESS_REDIS: redis://broker:6379
      PAPERLESS_DBHOST: db
      PAPERLESS_TIKA_ENABLED: 1
      PAPERLESS_TIKA_GOTENBERG_ENDPOINT: http://gotenberg:3000
      PAPERLESS_TIKA_ENDPOINT: http://tika:9998
      PAPERLESS_OAUTH_CALLBACK_BASE_URL: https://paperless.ccalifice.com
      PAPERLESS_URL: https://paperless.ccalifice.com
      PAPERLESS_OUTLOOK_OAUTH_CLIENT_ID: '0285b467-7522-4845-ac05-3e89aa2e1024'
      PAPERLESS_OUTLOOK_OAUTH_CLIENT_SECRET: 'l1F8Q~TqHOiy~6CL2kXEIjIQz-SoaJ.AuQ_0saN9'
      USERMAP_UID: 1000
      USERMAP_GID: 1002
    networks:
      - default
      - caddy-net

  gotenberg:
    image: docker.io/gotenberg/gotenberg:8.25
    restart: unless-stopped
    # The gotenberg chromium route is used to convert .eml files. We do not
    # want to allow external content like tracking pixels or even javascript.
    command:
      - "gotenberg"
      - "--chromium-disable-javascript=true"
      - "--chromium-allow-list=file:///tmp/.*"
  tika:
    image: docker.io/apache/tika:latest
    restart: unless-stopped

networks:
  caddy-net:
    external: true
    name: caddy-net
  paperless-net:
